#include <iostream>
using namespace std;

const long long mod = 1000000007;

struct node{
    long long ways[3][3];
    int from, to;
    node(){
        from=-1; to=-1;
        for (int i=0; i<3; ++i){
            for (int j=0; j<3; ++j){
                ways[i][j]=0;
            }
        }
    }
};

int m, n, q;
node tree[200200];
int leaf[100100];

void mark(int ind, int from, int to){
    tree[ind].from = from;
    tree[ind].to = to;
    if (from == to-1){leaf[from]=ind; return;}
    int mid = (from+to)/2;
    mark(ind*2, from, mid);
    mark(ind*2+1, mid, to);
}

void update(int ind, int l, int r, int add){
    tree[ind].ways[l][r]+=add;
    for (int i=ind/2; i>0; i/=2){
        for (int left=0; left<3; ++left){
            for (int right=0; right<3; ++right){
                tree[i].ways[left][right]=0;
                for (int j=0; j<3; ++j){
                    tree[i].ways[left][right] += tree[i*2].ways[left][j] * tree[i*2+1].ways[2-j][right];
                    tree[i].ways[left][right] %= mod;
                }
            }
        }
    }
}

int main(){
    ios_base::sync_with_stdio(false);
    cin>>m>>n>>q;
    mark(1, 0, n);
    for (int i=0; i<m; ++i){
        int pos, l, r;
        cin>>pos>>l>>r;
        pos--;
        l%=3;r%=3;
        update(leaf[pos], l, r, 1);
    }
    cout<<tree[1].ways[1][1]<<endl;
    for (int i=0; i<q; ++i){
        int type, pos, l, r;
        cin>>type>>pos>>l>>r;
        type = (type%2)*2 - 1;
        pos--;
        l%=3;r%=3;
        update(leaf[pos], l, r, type);
        cout<<tree[1].ways[1][1]<<endl;
    }
    return 0;
}
/*
8 3 5
1 1 1
1 1 2
1 2 1
2 1 2
2 3 3
2 1 3
3 2 1
3 3 2
1 3 3 1
2 3 2 1
1 2 3 2
1 2 3 2
1 3 2 1
*/
